> For the complete documentation index, see [llms.txt](https://help.security.gallagher.com/knowledge-hub/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://help.security.gallagher.com/knowledge-hub/developer/rest-api/outputs.md).

# Outputs

These methods give you read access to Outputs in the Command Centre database, and let you override them.

The first use case below introduces the main entry point. It is a paginated search interface that gives you any number of outputs, each containing the fields you ask for in the query, including (for example) the URLs you need to switch the outputs on and off.

### Override times

1. End times on overrides are not accurate to the second. Internally, Command Centre converts the end time to a duration, so you may find that submitting end times in the very near future does not have the exact effect you expect.
2. The end time you set for an override cannot be in the past or more than 24 hours into the future.

### Overrides always use 'on' and 'off'

The Configuration client allows you to assign different display strings to the two normal output states, on and off. On could be 'green', for example, and off could be 'red'. Regardless, the overrides you apply to an output are called 'on' and 'off'.

### Output status flags

Status flags, on the other hand, use the language of the relays on the hardware modules. They will report 'closed' for an output that is on, and 'open' for one that is off.

If the output is online, its `statusFlags` field may contain one or more of these flags:

* `relayStateUnknown` means the controller does not know what the output should be doing.
* `closed` means the output relay is closed.
* `open` means the output relay is open.
* `pulsed` means the relay's change in state is momentary.
* `switchingDisabled` means switching this output is disabled.
* `overridden` can appear whether the output is online or offline. It means the output has an override in effect.

#### Output flag rules

* If and only if the output is online, one of 'relayStateUnknown', 'closed', or 'open' will appear. That is your test for whether an output is in error.
* Of the above, only 'overridden' can appear when the output is offline.

### Use cases

#### Listing Outputs

1. `GET /api`.
2. Follow the link at `features.outputs.outputs.href` ↪, appending a search term such as `name=substring` to select the outputs, and `fields` to tell the server what to return about each. The next section covers those query parameters.
3. Process the results, following the `next` link until there isn't one.

#### Switching an Output

1. Find the href for the output using the process above.
2. GET it.
3. Look in the `commands` structure of the results to find the API URLs that turn the output on, off, or cancel a previous override. Use the `until` variants if you want to specify an end time.
4. POST to that URL. Those with `until` in their command block keys require a JSON object in the body; the others expect it empty.

#### Finding an output's status

1. Find the href for the output using the process above, and GET it.
2. Take the `updates` ↪ href from that page.
3. GET it.
4. Use the flag rules above to interpret the status flags you receive.
5. Follow the `next` link to stay up to date.

### Licensing

All the POSTs that override items require RESTOverrides.

If you have RESTOverrides but not RESTStatus in 8.60 or later, the GETs return enough information to let you find the item you want to override but they do not return its status. In 8.50 and older, the GET will fail without RESTStatus.

The RESTOverrides and RESTStatus licences do not overlap: to watch the status of an item as well as override it, you will need both.

## Search outputs

> This returns a summary of the outputs matching your search criteria.\
> \
> The result will contain no more than 100 or 1000 outputs (depending on your version), or as\
> many as you asked for; you should follow the \`next\` link, if it is\
> present, to collect the next batch.\
> \
> If your result set is empty it means your operator does not have the privilege to view any\
> outputs, such as 'View Site', 'Edit Site', or 'Override'.  Perhaps there are no outputs in\
> the divisions in which your operator has privileges, or your operator has no privileges at\
> all.\
> \
> When you have loaded them all there will be no \`next\` link.\
> \
> Do not code this URL into your application.  Take it from the 'href' field in the\
> \`features.outputs.outputs\` section of \`/api\`.<br>

```json
{"openapi":"3.2.0","info":{"title":"Command Centre REST API","version":"2.0"},"tags":[{"name":"Outputs","description":"These methods give you read access to Outputs in the Command Centre\ndatabase, and let you override them.\n\nThe first use case below introduces the main entry point.  It is a paginated search interface\nthat gives you any number of outputs, each containing the fields you ask for in the query,\nincluding (for example) the URLs you need to switch the outputs on and off.\n\n## Override times\n\n1. End times on overrides are not accurate to the second.  Internally, Command Centre\n   converts the end time to a duration, so you may find that submitting end times in\n   the very near future does not have the exact effect you expect.\n2. The end time you set for an override cannot be in the past or more than 24 hours\n   into the future.\n\n## Overrides always use 'on' and 'off'\n\nThe Configuration client allows you to assign different display strings to the two normal output\nstates, on and off.  On could be 'green', for example, and off could be 'red'.  Regardless, the\noverrides you apply to an output are called 'on' and 'off'.\n\n## Output status flags\n\nStatus flags, on the other hand, use the language of the relays on the hardware modules.  They\nwill report 'closed' for an output that is on, and 'open' for one that is off.\n\nIf the output is online, its `statusFlags` field may contain one or more of these flags:\n\n- `relayStateUnknown` means the controller does not know what the output should be doing.\n- `closed` means the output relay is closed.\n- `open` means the output relay is open.\n- `pulsed` means the relay's change in state is momentary.\n- `switchingDisabled` means switching this output is disabled.\n\n- `overridden` can appear whether the output is online or offline.  It means the output has an\n  override in effect.\n\n### Output flag rules\n\n- If and only if the output is online, one of 'relayStateUnknown', 'closed', or 'open' will\n  appear.  That is your test for whether an output is in error.\n- Of the above, only 'overridden' can appear when the output is offline.\n\n## Use cases\n\n### Listing Outputs\n1. `GET /api`.\n2. Follow the link at `features.outputs.outputs.href` [↪](outputs#get-api-outputs),\n   appending a search term such as `name=substring` to select the outputs, and `fields` to tell\n   the server what to return about each.  The next section covers those query parameters.\n3. Process the results, following the `next` link until there isn't one.\n\n### Switching an Output\n1. Find the href for the output using the process above.\n2. GET it.\n3. Look in the `commands` structure of the [results](models#outputdetail) to find the API\n   URLs that turn the output on, off, or cancel a previous override.  Use the `until` variants\n   if you want to specify an end time.\n4. POST to that URL.  Those with `until` in their command block keys require a JSON\n   object in the body; the others expect it empty.\n\n### Finding an output's status\n1. Find the href for the output using the process above, and GET it.\n3. Take the `updates` [↪](outputs#get-api-outputs-id-updates) href from that page.\n4. GET it.\n4. Use the flag rules above to interpret the status flags you receive.\n5. Follow the `next` link to stay up to date.\n\n## Licensing\n\nAll the POSTs that override items require RESTOverrides.\n\nIf you have RESTOverrides but not RESTStatus in 8.60 or later, the GETs return enough\ninformation to let you find the item you want to override but they do not return its status.  In\n8.50 and older, the GET will fail without RESTStatus.\n\nThe RESTOverrides and RESTStatus licences do not overlap: to watch the status of an item as well\nas override it, you will need both."}],"servers":[{"url":"https://127.0.0.1:8904"}],"security":[{"API_key":[]},{"basic":[]}],"components":{"securitySchemes":{"API_key":{"type":"apiKey","name":"Authorization","in":"header","description":"\nClients authenticate by including a pre-shared API key in the `Authorization` header of each\nrequest after an authorisation method of `GGL-API-KEY`:\n\n`Authorization: GGL-API-KEY C774-B01F-D695-AA4B-215F-A158-AC22-ADEB`\n\nFor a fuller description see [API authentication](api-authentication).\n"},"basic":{"type":"http","scheme":"basic","description":"This is HTTP Basic authentication using a blank username and the API key as the password.\n\nExample:  `Authorization: Basic OkM3NzQtQjAxRi1ENjk1LUFBNEItMjE1Ri1BMTU4LUFDMjItQURFQg==`\n\nThat example is equivalent to the example in the description of the api_Key method:\nprepending a colon to the API key beginning with `C774` then encoding it into Base64\nproduces the 56 characters beginning with `OkM3`.\n\nThe colon is a separator between a username, which is blank in our case, and the password,\nwhich is our API key.\n\nFor a fuller description see [API authentication](api-authentication)\n"}},"parameters":{"sort":{"name":"sort","in":"query","schema":{"type":"string","enum":["id","name","-id","-name"]},"required":false,"description":"Changes the sort field between database ID and name.\n\nIf you prefix `id` or `name` with a minus sign (ASCII 45), the sort order is reversed.\n\nThere are two very strong reasons to sort by ID:\n\n1. Sorting by name carries a risk of missing or duplicating objects if your result set spans\n   multiple pages and another operator is editing the database while your REST client is\n   enumerating them.  This is known as \"page drift.\"  Sorting by ID does not carry that risk.\n2. Following a `next` link is _dramatically_ quicker when sorting by ID.\n\nWe _strongly_ recommend sorting by ID.  In case you were still in doubt, we will do that by\ndefault in a future version of Command Centre.\n\nThe server silently ignores anything except the options listed here.\n"},"top":{"name":"top","in":"query","required":false,"schema":{"type":"integer","minimum":1},"description":"Limits the results to no more than this many items per page.\n\nOlder versions of Command Centre returned 100 items per page in the absence of this parameter.  That is acceptable for GUI\napplications that will only display the first page, but for integrations that intend to\nproceed through the entire database it causes a lot of chatter.\n\n8.70 and later versions will default to 1000 items per request.  This is about where a graph\nof throughput versus page size begins to level out.\n"},"name":{"name":"name","in":"query","schema":{"type":"string"},"description":"Limits the returned items to those with a name that matches this string.  Without surrounding\nquotes or a percent sign or underscore, it is a substring match; surround the parameter with\ndouble quotes `\"...\"` for an exact match.  Without quotes, a percent sign `%` will match any\nsubstring and an underscore will match any single character.\n\nThe search is always case-insensitive.  Results are undefined if you do a substring search for\nthe empty string (`name=`).  You will receive no items if you search for those with no name\n(`name=\"\"`), as all items must have a name.\n\nSearch parameters are ANDed together.\n"},"division":{"name":"division","in":"query","required":false,"schema":{"type":"array","items":{"type":"string"}},"style":"form","explode":false,"description":"Limits the returned items to those that are in these divisions.\n\nThat includes all the items in those divisions' child divisions, because Command Centre treats\nitems as though they are also in their division's parent, and its parent, and so on up to the\nroot division.\n\nSeparate the IDs of the divisions in you are interested with commas.  Item IDs are short\nalphanumeric strings, not URLs.\n\nResults are undefined if you provide an ID that is not in the form of a division ID.\n\nSearch parameters are ANDed together.\n"},"directDivision":{"name":"directDivision","in":"query","required":false,"schema":{"type":"array","items":{"type":"string"}},"style":"form","explode":false,"description":"Restricts items to those whose division is in this list.\n\nUnlike `division=`, it does not follow ancestry.  That means it will limit the search to items\nthat are directly assigned to the divisions you list, whereas `division` (without the\n`direct`) will also include items that are assigned to their descendants.\n\nList the IDs of the divisions you are interested in separated by commas.  Item IDs are short\nalphanumeric strings, not URLs.\n\nBecause this is the first query parameter we added that contains a capital letter, this will\nbe the first time you have had to think about case sensitivity.  `directDivision` works,\n`directdivision` does not.\n\nResults are undefined if you provide an ID that is not in the form of a division ID.\n\nSearch parameters are ANDed together.\n\nAdded in 9.20.\n"},"description":{"name":"description","in":"query","required":false,"schema":{"type":"string"},"description":"Limits the returned items to those with a description that matches this string.  By default it\nis a substring match; surround it with double quotes `\"...\"` for an exact match.  A `_` will\nmatch any single character, and a `%` will match any substring.  With or without quotes,\nhaving either of these wildcards in the string will anchor it at both ends as though you had\nsurrounded it with `\"`.\n\nThe search is always case-insensitive.  Results are undefined if you search for the empty\nstring (`description=` or `description=\"\"`).\n\nSearch parameters are ANDed together.\n"},"pos":{"name":"pos","in":"query","required":false,"schema":{"type":"integer"},"description":"Reserved for internal use.  You may see it in URLs you receive from the server, but you must never add it yourself."},"skip":{"name":"skip","in":"query","required":false,"schema":{"type":"integer"},"description":"Reserved for internal use.  Do not add it to your queries."}},"schemas":{"OutputSearch":{"title":"Output search","description":"An array of output summaries, and a `next` link for more.","properties":{"results":{"type":"array","description":"An array of output summaries.","items":{"$ref":"#/components/schemas/OutputSummary"}},"next":{"type":"object","description":"The link to the next page.  Absent if you have retrieved them all.","properties":{"href":{"type":"string","format":"uri-reference"}}}}},"OutputSummary":{"title":"Output summary","description":"`/api/outputs` returns an array of these.  It is a subset of what you get from an\noutput's detail page at `/api/outputs/{id}` (linked as the href in this object).\n","properties":{"href":{"type":"string","format":"uri-reference","description":"A link to an [output detail](models#outputdetail) object for this output.\n"},"id":{"type":"string","description":"An alphanumeric identifier, unique to the server. This is the ID to use in the `source`\nparameter of [event filters](events#get-api-events) if you are only\ninterested in events from particular outputs.\n"},"name":{"type":"string"}}}},"responses":{"403nolicence":{"description":"A server running 8.50 or earlier is missing the RESTStatus licence.  A server running 8.60\nor later is missing both the RESTStatus and RESTOverrides licences.  One of those is enough\nfor this API call in 8.60 and later.\n"}}},"paths":{"/api/outputs":{"get":{"tags":["Outputs"],"summary":"Search outputs","description":"This returns a summary of the outputs matching your search criteria.\n\nThe result will contain no more than 100 or 1000 outputs (depending on your version), or as\nmany as you asked for; you should follow the `next` link, if it is\npresent, to collect the next batch.\n\nIf your result set is empty it means your operator does not have the privilege to view any\noutputs, such as 'View Site', 'Edit Site', or 'Override'.  Perhaps there are no outputs in\nthe divisions in which your operator has privileges, or your operator has no privileges at\nall.\n\nWhen you have loaded them all there will be no `next` link.\n\nDo not code this URL into your application.  Take it from the 'href' field in the\n`features.outputs.outputs` section of `/api`.\n","parameters":[{"$ref":"#/components/parameters/sort"},{"$ref":"#/components/parameters/top"},{"$ref":"#/components/parameters/name"},{"$ref":"#/components/parameters/division"},{"$ref":"#/components/parameters/directDivision"},{"$ref":"#/components/parameters/description"},{"name":"fields","in":"query","required":false,"style":"form","explode":false,"description":"This instructs the server to return only these fields in the search results.  The values you can list are the same as the field\nnames in the details page.  Using this you can return everything on the summary page that you\nwould find on the details page.  Separate values with commas.\n\nUse the special value `defaults` to return the fields you would have received had you not given\nthe parameter at all.  Obviously only do that if you have more to add.\n\nTreat the string matches as case-sensitive.\n\nIn v8.00 you will receive the href and internal ID even if you did not ask for them.  In 8.10\nand later you will only get what you asked for.  If you are going to send the `fields`\nparameter and need the href or ID, be explicit.\n","schema":{"type":"string","enum":["href","id","name","shortName","description","division","commands","connectedController","statusFlags","statusText","status","notes","updates","defaults"]}},{"$ref":"#/components/parameters/pos"},{"$ref":"#/components/parameters/skip"}],"responses":{"200":{"description":"Success.  See the note in the description about privileges if your result set is empty.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/OutputSearch"}}}},"403":{"$ref":"#/components/responses/403nolicence"}}}}}}
```

## Get details of an output

> This returns the detail of one output.\
> \
> Follow the 'href' field in an \[output summary]\(models#outputsummary) to get here.<br>

```json
{"openapi":"3.2.0","info":{"title":"Command Centre REST API","version":"2.0"},"tags":[{"name":"Outputs","description":"These methods give you read access to Outputs in the Command Centre\ndatabase, and let you override them.\n\nThe first use case below introduces the main entry point.  It is a paginated search interface\nthat gives you any number of outputs, each containing the fields you ask for in the query,\nincluding (for example) the URLs you need to switch the outputs on and off.\n\n## Override times\n\n1. End times on overrides are not accurate to the second.  Internally, Command Centre\n   converts the end time to a duration, so you may find that submitting end times in\n   the very near future does not have the exact effect you expect.\n2. The end time you set for an override cannot be in the past or more than 24 hours\n   into the future.\n\n## Overrides always use 'on' and 'off'\n\nThe Configuration client allows you to assign different display strings to the two normal output\nstates, on and off.  On could be 'green', for example, and off could be 'red'.  Regardless, the\noverrides you apply to an output are called 'on' and 'off'.\n\n## Output status flags\n\nStatus flags, on the other hand, use the language of the relays on the hardware modules.  They\nwill report 'closed' for an output that is on, and 'open' for one that is off.\n\nIf the output is online, its `statusFlags` field may contain one or more of these flags:\n\n- `relayStateUnknown` means the controller does not know what the output should be doing.\n- `closed` means the output relay is closed.\n- `open` means the output relay is open.\n- `pulsed` means the relay's change in state is momentary.\n- `switchingDisabled` means switching this output is disabled.\n\n- `overridden` can appear whether the output is online or offline.  It means the output has an\n  override in effect.\n\n### Output flag rules\n\n- If and only if the output is online, one of 'relayStateUnknown', 'closed', or 'open' will\n  appear.  That is your test for whether an output is in error.\n- Of the above, only 'overridden' can appear when the output is offline.\n\n## Use cases\n\n### Listing Outputs\n1. `GET /api`.\n2. Follow the link at `features.outputs.outputs.href` [↪](outputs#get-api-outputs),\n   appending a search term such as `name=substring` to select the outputs, and `fields` to tell\n   the server what to return about each.  The next section covers those query parameters.\n3. Process the results, following the `next` link until there isn't one.\n\n### Switching an Output\n1. Find the href for the output using the process above.\n2. GET it.\n3. Look in the `commands` structure of the [results](models#outputdetail) to find the API\n   URLs that turn the output on, off, or cancel a previous override.  Use the `until` variants\n   if you want to specify an end time.\n4. POST to that URL.  Those with `until` in their command block keys require a JSON\n   object in the body; the others expect it empty.\n\n### Finding an output's status\n1. Find the href for the output using the process above, and GET it.\n3. Take the `updates` [↪](outputs#get-api-outputs-id-updates) href from that page.\n4. GET it.\n4. Use the flag rules above to interpret the status flags you receive.\n5. Follow the `next` link to stay up to date.\n\n## Licensing\n\nAll the POSTs that override items require RESTOverrides.\n\nIf you have RESTOverrides but not RESTStatus in 8.60 or later, the GETs return enough\ninformation to let you find the item you want to override but they do not return its status.  In\n8.50 and older, the GET will fail without RESTStatus.\n\nThe RESTOverrides and RESTStatus licences do not overlap: to watch the status of an item as well\nas override it, you will need both."}],"servers":[{"url":"https://127.0.0.1:8904"}],"security":[{"API_key":[]},{"basic":[]}],"components":{"securitySchemes":{"API_key":{"type":"apiKey","name":"Authorization","in":"header","description":"\nClients authenticate by including a pre-shared API key in the `Authorization` header of each\nrequest after an authorisation method of `GGL-API-KEY`:\n\n`Authorization: GGL-API-KEY C774-B01F-D695-AA4B-215F-A158-AC22-ADEB`\n\nFor a fuller description see [API authentication](api-authentication).\n"},"basic":{"type":"http","scheme":"basic","description":"This is HTTP Basic authentication using a blank username and the API key as the password.\n\nExample:  `Authorization: Basic OkM3NzQtQjAxRi1ENjk1LUFBNEItMjE1Ri1BMTU4LUFDMjItQURFQg==`\n\nThat example is equivalent to the example in the description of the api_Key method:\nprepending a colon to the API key beginning with `C774` then encoding it into Base64\nproduces the 56 characters beginning with `OkM3`.\n\nThe colon is a separator between a username, which is blank in our case, and the password,\nwhich is our API key.\n\nFor a fuller description see [API authentication](api-authentication)\n"}},"parameters":{"id":{"name":"id","in":"path","required":true,"schema":{"type":"string"},"description":"An internal identifier."}},"schemas":{"OutputDetail":{"title":"Output detail","description":"[/api/outputs/{id}](outputs#get-api-outputs-id-) returns one of these.\n","allOf":[{"$ref":"#/components/schemas/OutputSummary"},{"type":"object","properties":{"description":{"type":"string"},"division":{"type":"object","description":"The division containing this output."},"shortName":{"type":"string","maxLength":16,"description":"Short names are not displayed by default.  You must ask for them using the\n'fields' parameter:\n\n`?fields=shortname,...`.\n"},"notes":{"type":"string","description":"Because of their potential size, notes are only available by request.  Use the 'fields'\nparameter:\n\n`?fields=defaults,notes,...`\n"},"updates":{"type":"object","properties":{"href":{"type":"string","format":"uri-reference"}},"description":"Follow the URL in the href inside this block to receive the item's current status, then follow\nthe `next` link in the results to long poll for changes to that status.\n\nThis method only monitors one item at a time.  To monitor the status of many items, use the\n[status-monitoring routes](#?route=post-/api/items/updates).\n\nUpdate pages take the same `fields` parameter as summary and details pages.  You should use\nthat to request all the fields you need in the update.\n"},"statusFlags":{"type":"array","items":{"type":"string"},"description":"The search and details pages do not return status flags by default, because an item's status\nis unknown until something is monitoring it.  If you want status flags on the search and\ndetails pages you must ask for them using the `fields` parameter, but our advice is to monitor\nthem using [status subscriptions](items#status-subscriptions) if you are running 8.30 or\nlater, otherwise the item's `updates` link.  See the [item status](item-status) section\nfor a full description of how to stay up to date with item status, and this item's\nintroduction in the Operations section for what flags this item might return and what they\nmean.\n"},"connectedController":{"type":"object","description":"This block describes this item's hardware controller.\n\nRetrieving it takes a little more time than the other fields so only ask for it if you\nneed it.\n\nAdded in 8.50.\n","properties":{"name":{"type":"string"},"href":{"type":"string","format":"uri-reference","description":"This is the REST API's identifier for the hardware controller.  It is only an\nidentifier, not a usable URL, because there is no interface for hardware\ncontrollers.  GETting the URL will return a 404.\n"},"id":{"type":"string","description":"An alphanumeric identifier, unique to the server.  This is the ID to use in the `source`\nparameter of [event filters](events#get-api-events).\n"}}},"commands":{"type":"object","description":"A block of commands keyed by a fixed enumeration given below.  The values are blocks\ncontaining an href that accepts a POST that will send an override to the output,\nturning it on or off.\n\nIt will be missing if your operator does not have a privilege that allows overriding\nthe output (examples of which are in the documentation for the POSTs).\n","properties":{"on":{"type":"object","properties":{"href":{"description":"[POST](outputs#post-api-outputs-id-on) to this to close this output.\n","type":"string","format":"uri-reference"}}},"onUntil":{"type":"object","properties":{"href":{"description":"[POST](outputs#post-api-outputs-id-on) to this to close this output for\na fixed time.\n","type":"string","format":"uri-reference"}}},"off":{"type":"object","properties":{"href":{"description":"[POST](outputs#post-api-outputs-id-off) to this to open this output.\n","type":"string","format":"uri-reference"}}},"offUntil":{"type":"object","properties":{"href":{"description":"[POST](outputs#post-api-outputs-id-off) to this to open this output for\na fixed time.\n","type":"string","format":"uri-reference"}}},"pulse":{"type":"object","properties":{"href":{"description":"[POST](outputs#post-api-outputs-id-pulse) to this to close this output\nfor its pulse time.\n\nThis link will only be here if the output is set to pulse when activated.\n\nAdded in 8.50.\n","type":"string","format":"uri-reference"}}}}}}}]},"OutputSummary":{"title":"Output summary","description":"`/api/outputs` returns an array of these.  It is a subset of what you get from an\noutput's detail page at `/api/outputs/{id}` (linked as the href in this object).\n","properties":{"href":{"type":"string","format":"uri-reference","description":"A link to an [output detail](models#outputdetail) object for this output.\n"},"id":{"type":"string","description":"An alphanumeric identifier, unique to the server. This is the ID to use in the `source`\nparameter of [event filters](events#get-api-events) if you are only\ninterested in events from particular outputs.\n"},"name":{"type":"string"}}}},"responses":{"403nolicence":{"description":"A server running 8.50 or earlier is missing the RESTStatus licence.  A server running 8.60\nor later is missing both the RESTStatus and RESTOverrides licences.  One of those is enough\nfor this API call in 8.60 and later.\n"},"404output":{"description":"The request's URL does not represent an output, or the operator does not have a privilege\non the output's division that allows viewing outputs, such as 'View Site', 'Edit Site', or\n'Override'.\n"}}},"paths":{"/api/outputs/{id}":{"get":{"tags":["Outputs"],"summary":"Get details of an output","description":"This returns the detail of one output.\n\nFollow the 'href' field in an [output summary](models#outputsummary) to get here.\n","parameters":[{"$ref":"#/components/parameters/id"},{"name":"fields","in":"query","style":"form","explode":false,"description":"This instructs the server to return only these fields in the details page instead of the default set.  The values you can list\nare the same as the field names you would see in the results.  Use it to cut back on the size\nof the response.  Separate values with commas.\n\nTreat the string matches as case-sensitive.\n\nIn v8.00 you will receive the href and internal ID even if you did not ask for them.  In 8.10\nand later you will only get what you asked for.  If you are going to send the `fields`\nparameter and need the href or ID, be explicit.\n","schema":{"type":"string","enum":["href","id","name","shortName","description","division","commands","connectedController","statusFlags","statusText","status","notes","updates","defaults"]}}],"responses":{"200":{"description":"Success.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/OutputDetail"}}}},"403":{"$ref":"#/components/responses/403nolicence"},"404":{"$ref":"#/components/responses/404output"}}}}}}
```

## Turn on an output

> Sends an override to close an output.\
> \
> If you send an end time in the body, the override will only stay in effect until\
> then.<br>

```json
{"openapi":"3.2.0","info":{"title":"Command Centre REST API","version":"2.0"},"tags":[{"name":"Outputs","description":"These methods give you read access to Outputs in the Command Centre\ndatabase, and let you override them.\n\nThe first use case below introduces the main entry point.  It is a paginated search interface\nthat gives you any number of outputs, each containing the fields you ask for in the query,\nincluding (for example) the URLs you need to switch the outputs on and off.\n\n## Override times\n\n1. End times on overrides are not accurate to the second.  Internally, Command Centre\n   converts the end time to a duration, so you may find that submitting end times in\n   the very near future does not have the exact effect you expect.\n2. The end time you set for an override cannot be in the past or more than 24 hours\n   into the future.\n\n## Overrides always use 'on' and 'off'\n\nThe Configuration client allows you to assign different display strings to the two normal output\nstates, on and off.  On could be 'green', for example, and off could be 'red'.  Regardless, the\noverrides you apply to an output are called 'on' and 'off'.\n\n## Output status flags\n\nStatus flags, on the other hand, use the language of the relays on the hardware modules.  They\nwill report 'closed' for an output that is on, and 'open' for one that is off.\n\nIf the output is online, its `statusFlags` field may contain one or more of these flags:\n\n- `relayStateUnknown` means the controller does not know what the output should be doing.\n- `closed` means the output relay is closed.\n- `open` means the output relay is open.\n- `pulsed` means the relay's change in state is momentary.\n- `switchingDisabled` means switching this output is disabled.\n\n- `overridden` can appear whether the output is online or offline.  It means the output has an\n  override in effect.\n\n### Output flag rules\n\n- If and only if the output is online, one of 'relayStateUnknown', 'closed', or 'open' will\n  appear.  That is your test for whether an output is in error.\n- Of the above, only 'overridden' can appear when the output is offline.\n\n## Use cases\n\n### Listing Outputs\n1. `GET /api`.\n2. Follow the link at `features.outputs.outputs.href` [↪](outputs#get-api-outputs),\n   appending a search term such as `name=substring` to select the outputs, and `fields` to tell\n   the server what to return about each.  The next section covers those query parameters.\n3. Process the results, following the `next` link until there isn't one.\n\n### Switching an Output\n1. Find the href for the output using the process above.\n2. GET it.\n3. Look in the `commands` structure of the [results](models#outputdetail) to find the API\n   URLs that turn the output on, off, or cancel a previous override.  Use the `until` variants\n   if you want to specify an end time.\n4. POST to that URL.  Those with `until` in their command block keys require a JSON\n   object in the body; the others expect it empty.\n\n### Finding an output's status\n1. Find the href for the output using the process above, and GET it.\n3. Take the `updates` [↪](outputs#get-api-outputs-id-updates) href from that page.\n4. GET it.\n4. Use the flag rules above to interpret the status flags you receive.\n5. Follow the `next` link to stay up to date.\n\n## Licensing\n\nAll the POSTs that override items require RESTOverrides.\n\nIf you have RESTOverrides but not RESTStatus in 8.60 or later, the GETs return enough\ninformation to let you find the item you want to override but they do not return its status.  In\n8.50 and older, the GET will fail without RESTStatus.\n\nThe RESTOverrides and RESTStatus licences do not overlap: to watch the status of an item as well\nas override it, you will need both."}],"servers":[{"url":"https://127.0.0.1:8904"}],"security":[{"API_key":[]},{"basic":[]}],"components":{"securitySchemes":{"API_key":{"type":"apiKey","name":"Authorization","in":"header","description":"\nClients authenticate by including a pre-shared API key in the `Authorization` header of each\nrequest after an authorisation method of `GGL-API-KEY`:\n\n`Authorization: GGL-API-KEY C774-B01F-D695-AA4B-215F-A158-AC22-ADEB`\n\nFor a fuller description see [API authentication](api-authentication).\n"},"basic":{"type":"http","scheme":"basic","description":"This is HTTP Basic authentication using a blank username and the API key as the password.\n\nExample:  `Authorization: Basic OkM3NzQtQjAxRi1ENjk1LUFBNEItMjE1Ri1BMTU4LUFDMjItQURFQg==`\n\nThat example is equivalent to the example in the description of the api_Key method:\nprepending a colon to the API key beginning with `C774` then encoding it into Base64\nproduces the 56 characters beginning with `OkM3`.\n\nThe colon is a separator between a username, which is blank in our case, and the password,\nwhich is our API key.\n\nFor a fuller description see [API authentication](api-authentication)\n"}},"parameters":{"id":{"name":"id","in":"path","required":true,"schema":{"type":"string"},"description":"An internal identifier."},"requested_by":{"name":"requested_by","in":"query","required":false,"schema":{"type":"string"},"description":"Attributes this override to the cardholder with this ID rather than the REST operator.\nPrivilege checks will use the operator as normal, but event monitors and reports will state\nthat the person responsible for the override was the attributed cardholder, not the REST\noperator.  The REST operator will appear in a special mention in the event's details.\n\nFirst available in 8.70.  Versions older than 8.70 will ignore the parameter, leaving the\noverride attributed to the REST operator.\n"}},"requestBodies":{"OverrideEndTime":{"description":"Put this in the body of override POSTs to set the time at which the override should cease.\nThe API will reject the override if the string is not empty and it cannot parse it into a\ndate-time, but it will treat the override as having no end time if you misspell 'endTime'\nor if you send a blank string.\n\nCommand Centre computes an override's duration to a whole number of minutes with a minimum\nof one.  That means that a timed override will always end at a multiple of sixty seconds\nfrom the time the hardware receives the override request, which means the override will end\nwithin thirty seconds of the time you supplied here.  In versions older than 8.80, the\ndiscrepancy may be up to a minute.\n\nCareful observation of overrides submitted from the Configuration client and from the API\nwill reveal that they use different rounding methods.  Be assured, both result in overrides\nending within a minute of the requested time.\n","required":false,"content":{"application/json":{"schema":{"type":"object","properties":{"endTime":{"type":"string","format":"date-time"}}}}}}},"responses":{"400badbody":{"description":"The server could not parse the POST parameters.  There could be a syntax error in your JSON.\n"},"403outputoverride":{"description":"The site does not have the RESTOverrides licence (in which case the body of the result will\nsay so), or the operator does not have a privilege that allows overriding outputs (such as\n'Override', or 'Maintenance Override' for shunts).\n"}}},"paths":{"/api/outputs/{id}/on":{"post":{"tags":["Outputs"],"summary":"Turn on an output","description":"Sends an override to close an output.\n\nIf you send an end time in the body, the override will only stay in effect until\nthen.\n","parameters":[{"$ref":"#/components/parameters/id"},{"$ref":"#/components/parameters/requested_by"}],"requestBody":{"$ref":"#/components/requestBodies/OverrideEndTime"},"responses":{"204":{"description":"Success."},"400":{"$ref":"#/components/responses/400badbody"},"403":{"$ref":"#/components/responses/403outputoverride"}}}}}}
```

## Pulse an output

> Sends an override to pulse an output.\
> \
> Pulsing an output differs from turning it on in two ways:\
> \
> &#x20; \- You cannot specify a duration for it to stay activated, because that comes from the\
> &#x20;   output's configuration.\
> \
> &#x20; \- A pulsed output will stay on for its pulse time even if another event seeks to\
> &#x20;   deactivate it (an 'off' override will still deactivate the output).\
> \
> Added in 8.50.<br>

```json
{"openapi":"3.2.0","info":{"title":"Command Centre REST API","version":"2.0"},"tags":[{"name":"Outputs","description":"These methods give you read access to Outputs in the Command Centre\ndatabase, and let you override them.\n\nThe first use case below introduces the main entry point.  It is a paginated search interface\nthat gives you any number of outputs, each containing the fields you ask for in the query,\nincluding (for example) the URLs you need to switch the outputs on and off.\n\n## Override times\n\n1. End times on overrides are not accurate to the second.  Internally, Command Centre\n   converts the end time to a duration, so you may find that submitting end times in\n   the very near future does not have the exact effect you expect.\n2. The end time you set for an override cannot be in the past or more than 24 hours\n   into the future.\n\n## Overrides always use 'on' and 'off'\n\nThe Configuration client allows you to assign different display strings to the two normal output\nstates, on and off.  On could be 'green', for example, and off could be 'red'.  Regardless, the\noverrides you apply to an output are called 'on' and 'off'.\n\n## Output status flags\n\nStatus flags, on the other hand, use the language of the relays on the hardware modules.  They\nwill report 'closed' for an output that is on, and 'open' for one that is off.\n\nIf the output is online, its `statusFlags` field may contain one or more of these flags:\n\n- `relayStateUnknown` means the controller does not know what the output should be doing.\n- `closed` means the output relay is closed.\n- `open` means the output relay is open.\n- `pulsed` means the relay's change in state is momentary.\n- `switchingDisabled` means switching this output is disabled.\n\n- `overridden` can appear whether the output is online or offline.  It means the output has an\n  override in effect.\n\n### Output flag rules\n\n- If and only if the output is online, one of 'relayStateUnknown', 'closed', or 'open' will\n  appear.  That is your test for whether an output is in error.\n- Of the above, only 'overridden' can appear when the output is offline.\n\n## Use cases\n\n### Listing Outputs\n1. `GET /api`.\n2. Follow the link at `features.outputs.outputs.href` [↪](outputs#get-api-outputs),\n   appending a search term such as `name=substring` to select the outputs, and `fields` to tell\n   the server what to return about each.  The next section covers those query parameters.\n3. Process the results, following the `next` link until there isn't one.\n\n### Switching an Output\n1. Find the href for the output using the process above.\n2. GET it.\n3. Look in the `commands` structure of the [results](models#outputdetail) to find the API\n   URLs that turn the output on, off, or cancel a previous override.  Use the `until` variants\n   if you want to specify an end time.\n4. POST to that URL.  Those with `until` in their command block keys require a JSON\n   object in the body; the others expect it empty.\n\n### Finding an output's status\n1. Find the href for the output using the process above, and GET it.\n3. Take the `updates` [↪](outputs#get-api-outputs-id-updates) href from that page.\n4. GET it.\n4. Use the flag rules above to interpret the status flags you receive.\n5. Follow the `next` link to stay up to date.\n\n## Licensing\n\nAll the POSTs that override items require RESTOverrides.\n\nIf you have RESTOverrides but not RESTStatus in 8.60 or later, the GETs return enough\ninformation to let you find the item you want to override but they do not return its status.  In\n8.50 and older, the GET will fail without RESTStatus.\n\nThe RESTOverrides and RESTStatus licences do not overlap: to watch the status of an item as well\nas override it, you will need both."}],"servers":[{"url":"https://127.0.0.1:8904"}],"security":[{"API_key":[]},{"basic":[]}],"components":{"securitySchemes":{"API_key":{"type":"apiKey","name":"Authorization","in":"header","description":"\nClients authenticate by including a pre-shared API key in the `Authorization` header of each\nrequest after an authorisation method of `GGL-API-KEY`:\n\n`Authorization: GGL-API-KEY C774-B01F-D695-AA4B-215F-A158-AC22-ADEB`\n\nFor a fuller description see [API authentication](api-authentication).\n"},"basic":{"type":"http","scheme":"basic","description":"This is HTTP Basic authentication using a blank username and the API key as the password.\n\nExample:  `Authorization: Basic OkM3NzQtQjAxRi1ENjk1LUFBNEItMjE1Ri1BMTU4LUFDMjItQURFQg==`\n\nThat example is equivalent to the example in the description of the api_Key method:\nprepending a colon to the API key beginning with `C774` then encoding it into Base64\nproduces the 56 characters beginning with `OkM3`.\n\nThe colon is a separator between a username, which is blank in our case, and the password,\nwhich is our API key.\n\nFor a fuller description see [API authentication](api-authentication)\n"}},"parameters":{"id":{"name":"id","in":"path","required":true,"schema":{"type":"string"},"description":"An internal identifier."},"requested_by":{"name":"requested_by","in":"query","required":false,"schema":{"type":"string"},"description":"Attributes this override to the cardholder with this ID rather than the REST operator.\nPrivilege checks will use the operator as normal, but event monitors and reports will state\nthat the person responsible for the override was the attributed cardholder, not the REST\noperator.  The REST operator will appear in a special mention in the event's details.\n\nFirst available in 8.70.  Versions older than 8.70 will ignore the parameter, leaving the\noverride attributed to the REST operator.\n"}},"responses":{"403outputoverride":{"description":"The site does not have the RESTOverrides licence (in which case the body of the result will\nsay so), or the operator does not have a privilege that allows overriding outputs (such as\n'Override', or 'Maintenance Override' for shunts).\n"}}},"paths":{"/api/outputs/{id}/pulse":{"post":{"tags":["Outputs"],"summary":"Pulse an output","description":"Sends an override to pulse an output.\n\nPulsing an output differs from turning it on in two ways:\n\n  - You cannot specify a duration for it to stay activated, because that comes from the\n    output's configuration.\n\n  - A pulsed output will stay on for its pulse time even if another event seeks to\n    deactivate it (an 'off' override will still deactivate the output).\n\nAdded in 8.50.\n","parameters":[{"$ref":"#/components/parameters/id"},{"$ref":"#/components/parameters/requested_by"}],"responses":{"204":{"description":"Success."},"400":{"description":"The output is not configured for pulsing (8.70 and later only)."},"403":{"$ref":"#/components/responses/403outputoverride"}}}}}}
```

## Turn off an output

> Sends an override to open an output.\
> \
> If you send an end time in the body, the override will only stay in effect until\
> then.<br>

```json
{"openapi":"3.2.0","info":{"title":"Command Centre REST API","version":"2.0"},"tags":[{"name":"Outputs","description":"These methods give you read access to Outputs in the Command Centre\ndatabase, and let you override them.\n\nThe first use case below introduces the main entry point.  It is a paginated search interface\nthat gives you any number of outputs, each containing the fields you ask for in the query,\nincluding (for example) the URLs you need to switch the outputs on and off.\n\n## Override times\n\n1. End times on overrides are not accurate to the second.  Internally, Command Centre\n   converts the end time to a duration, so you may find that submitting end times in\n   the very near future does not have the exact effect you expect.\n2. The end time you set for an override cannot be in the past or more than 24 hours\n   into the future.\n\n## Overrides always use 'on' and 'off'\n\nThe Configuration client allows you to assign different display strings to the two normal output\nstates, on and off.  On could be 'green', for example, and off could be 'red'.  Regardless, the\noverrides you apply to an output are called 'on' and 'off'.\n\n## Output status flags\n\nStatus flags, on the other hand, use the language of the relays on the hardware modules.  They\nwill report 'closed' for an output that is on, and 'open' for one that is off.\n\nIf the output is online, its `statusFlags` field may contain one or more of these flags:\n\n- `relayStateUnknown` means the controller does not know what the output should be doing.\n- `closed` means the output relay is closed.\n- `open` means the output relay is open.\n- `pulsed` means the relay's change in state is momentary.\n- `switchingDisabled` means switching this output is disabled.\n\n- `overridden` can appear whether the output is online or offline.  It means the output has an\n  override in effect.\n\n### Output flag rules\n\n- If and only if the output is online, one of 'relayStateUnknown', 'closed', or 'open' will\n  appear.  That is your test for whether an output is in error.\n- Of the above, only 'overridden' can appear when the output is offline.\n\n## Use cases\n\n### Listing Outputs\n1. `GET /api`.\n2. Follow the link at `features.outputs.outputs.href` [↪](outputs#get-api-outputs),\n   appending a search term such as `name=substring` to select the outputs, and `fields` to tell\n   the server what to return about each.  The next section covers those query parameters.\n3. Process the results, following the `next` link until there isn't one.\n\n### Switching an Output\n1. Find the href for the output using the process above.\n2. GET it.\n3. Look in the `commands` structure of the [results](models#outputdetail) to find the API\n   URLs that turn the output on, off, or cancel a previous override.  Use the `until` variants\n   if you want to specify an end time.\n4. POST to that URL.  Those with `until` in their command block keys require a JSON\n   object in the body; the others expect it empty.\n\n### Finding an output's status\n1. Find the href for the output using the process above, and GET it.\n3. Take the `updates` [↪](outputs#get-api-outputs-id-updates) href from that page.\n4. GET it.\n4. Use the flag rules above to interpret the status flags you receive.\n5. Follow the `next` link to stay up to date.\n\n## Licensing\n\nAll the POSTs that override items require RESTOverrides.\n\nIf you have RESTOverrides but not RESTStatus in 8.60 or later, the GETs return enough\ninformation to let you find the item you want to override but they do not return its status.  In\n8.50 and older, the GET will fail without RESTStatus.\n\nThe RESTOverrides and RESTStatus licences do not overlap: to watch the status of an item as well\nas override it, you will need both."}],"servers":[{"url":"https://127.0.0.1:8904"}],"security":[{"API_key":[]},{"basic":[]}],"components":{"securitySchemes":{"API_key":{"type":"apiKey","name":"Authorization","in":"header","description":"\nClients authenticate by including a pre-shared API key in the `Authorization` header of each\nrequest after an authorisation method of `GGL-API-KEY`:\n\n`Authorization: GGL-API-KEY C774-B01F-D695-AA4B-215F-A158-AC22-ADEB`\n\nFor a fuller description see [API authentication](api-authentication).\n"},"basic":{"type":"http","scheme":"basic","description":"This is HTTP Basic authentication using a blank username and the API key as the password.\n\nExample:  `Authorization: Basic OkM3NzQtQjAxRi1ENjk1LUFBNEItMjE1Ri1BMTU4LUFDMjItQURFQg==`\n\nThat example is equivalent to the example in the description of the api_Key method:\nprepending a colon to the API key beginning with `C774` then encoding it into Base64\nproduces the 56 characters beginning with `OkM3`.\n\nThe colon is a separator between a username, which is blank in our case, and the password,\nwhich is our API key.\n\nFor a fuller description see [API authentication](api-authentication)\n"}},"parameters":{"id":{"name":"id","in":"path","required":true,"schema":{"type":"string"},"description":"An internal identifier."},"requested_by":{"name":"requested_by","in":"query","required":false,"schema":{"type":"string"},"description":"Attributes this override to the cardholder with this ID rather than the REST operator.\nPrivilege checks will use the operator as normal, but event monitors and reports will state\nthat the person responsible for the override was the attributed cardholder, not the REST\noperator.  The REST operator will appear in a special mention in the event's details.\n\nFirst available in 8.70.  Versions older than 8.70 will ignore the parameter, leaving the\noverride attributed to the REST operator.\n"}},"requestBodies":{"OverrideEndTime":{"description":"Put this in the body of override POSTs to set the time at which the override should cease.\nThe API will reject the override if the string is not empty and it cannot parse it into a\ndate-time, but it will treat the override as having no end time if you misspell 'endTime'\nor if you send a blank string.\n\nCommand Centre computes an override's duration to a whole number of minutes with a minimum\nof one.  That means that a timed override will always end at a multiple of sixty seconds\nfrom the time the hardware receives the override request, which means the override will end\nwithin thirty seconds of the time you supplied here.  In versions older than 8.80, the\ndiscrepancy may be up to a minute.\n\nCareful observation of overrides submitted from the Configuration client and from the API\nwill reveal that they use different rounding methods.  Be assured, both result in overrides\nending within a minute of the requested time.\n","required":false,"content":{"application/json":{"schema":{"type":"object","properties":{"endTime":{"type":"string","format":"date-time"}}}}}}},"responses":{"400badbody":{"description":"The server could not parse the POST parameters.  There could be a syntax error in your JSON.\n"},"403outputoverride":{"description":"The site does not have the RESTOverrides licence (in which case the body of the result will\nsay so), or the operator does not have a privilege that allows overriding outputs (such as\n'Override', or 'Maintenance Override' for shunts).\n"}}},"paths":{"/api/outputs/{id}/off":{"post":{"tags":["Outputs"],"summary":"Turn off an output","description":"Sends an override to open an output.\n\nIf you send an end time in the body, the override will only stay in effect until\nthen.\n","parameters":[{"$ref":"#/components/parameters/id"},{"$ref":"#/components/parameters/requested_by"}],"requestBody":{"$ref":"#/components/requestBodies/OverrideEndTime"},"responses":{"204":{"description":"Success."},"400":{"$ref":"#/components/responses/400badbody"},"403":{"$ref":"#/components/responses/403outputoverride"}}}}}}
```

## Cancel an override

> Cancels an override, returning the output to its previous state.<br>

```json
{"openapi":"3.2.0","info":{"title":"Command Centre REST API","version":"2.0"},"tags":[{"name":"Outputs","description":"These methods give you read access to Outputs in the Command Centre\ndatabase, and let you override them.\n\nThe first use case below introduces the main entry point.  It is a paginated search interface\nthat gives you any number of outputs, each containing the fields you ask for in the query,\nincluding (for example) the URLs you need to switch the outputs on and off.\n\n## Override times\n\n1. End times on overrides are not accurate to the second.  Internally, Command Centre\n   converts the end time to a duration, so you may find that submitting end times in\n   the very near future does not have the exact effect you expect.\n2. The end time you set for an override cannot be in the past or more than 24 hours\n   into the future.\n\n## Overrides always use 'on' and 'off'\n\nThe Configuration client allows you to assign different display strings to the two normal output\nstates, on and off.  On could be 'green', for example, and off could be 'red'.  Regardless, the\noverrides you apply to an output are called 'on' and 'off'.\n\n## Output status flags\n\nStatus flags, on the other hand, use the language of the relays on the hardware modules.  They\nwill report 'closed' for an output that is on, and 'open' for one that is off.\n\nIf the output is online, its `statusFlags` field may contain one or more of these flags:\n\n- `relayStateUnknown` means the controller does not know what the output should be doing.\n- `closed` means the output relay is closed.\n- `open` means the output relay is open.\n- `pulsed` means the relay's change in state is momentary.\n- `switchingDisabled` means switching this output is disabled.\n\n- `overridden` can appear whether the output is online or offline.  It means the output has an\n  override in effect.\n\n### Output flag rules\n\n- If and only if the output is online, one of 'relayStateUnknown', 'closed', or 'open' will\n  appear.  That is your test for whether an output is in error.\n- Of the above, only 'overridden' can appear when the output is offline.\n\n## Use cases\n\n### Listing Outputs\n1. `GET /api`.\n2. Follow the link at `features.outputs.outputs.href` [↪](outputs#get-api-outputs),\n   appending a search term such as `name=substring` to select the outputs, and `fields` to tell\n   the server what to return about each.  The next section covers those query parameters.\n3. Process the results, following the `next` link until there isn't one.\n\n### Switching an Output\n1. Find the href for the output using the process above.\n2. GET it.\n3. Look in the `commands` structure of the [results](models#outputdetail) to find the API\n   URLs that turn the output on, off, or cancel a previous override.  Use the `until` variants\n   if you want to specify an end time.\n4. POST to that URL.  Those with `until` in their command block keys require a JSON\n   object in the body; the others expect it empty.\n\n### Finding an output's status\n1. Find the href for the output using the process above, and GET it.\n3. Take the `updates` [↪](outputs#get-api-outputs-id-updates) href from that page.\n4. GET it.\n4. Use the flag rules above to interpret the status flags you receive.\n5. Follow the `next` link to stay up to date.\n\n## Licensing\n\nAll the POSTs that override items require RESTOverrides.\n\nIf you have RESTOverrides but not RESTStatus in 8.60 or later, the GETs return enough\ninformation to let you find the item you want to override but they do not return its status.  In\n8.50 and older, the GET will fail without RESTStatus.\n\nThe RESTOverrides and RESTStatus licences do not overlap: to watch the status of an item as well\nas override it, you will need both."}],"servers":[{"url":"https://127.0.0.1:8904"}],"security":[{"API_key":[]},{"basic":[]}],"components":{"securitySchemes":{"API_key":{"type":"apiKey","name":"Authorization","in":"header","description":"\nClients authenticate by including a pre-shared API key in the `Authorization` header of each\nrequest after an authorisation method of `GGL-API-KEY`:\n\n`Authorization: GGL-API-KEY C774-B01F-D695-AA4B-215F-A158-AC22-ADEB`\n\nFor a fuller description see [API authentication](api-authentication).\n"},"basic":{"type":"http","scheme":"basic","description":"This is HTTP Basic authentication using a blank username and the API key as the password.\n\nExample:  `Authorization: Basic OkM3NzQtQjAxRi1ENjk1LUFBNEItMjE1Ri1BMTU4LUFDMjItQURFQg==`\n\nThat example is equivalent to the example in the description of the api_Key method:\nprepending a colon to the API key beginning with `C774` then encoding it into Base64\nproduces the 56 characters beginning with `OkM3`.\n\nThe colon is a separator between a username, which is blank in our case, and the password,\nwhich is our API key.\n\nFor a fuller description see [API authentication](api-authentication)\n"}},"parameters":{"id":{"name":"id","in":"path","required":true,"schema":{"type":"string"},"description":"An internal identifier."},"requested_by":{"name":"requested_by","in":"query","required":false,"schema":{"type":"string"},"description":"Attributes this override to the cardholder with this ID rather than the REST operator.\nPrivilege checks will use the operator as normal, but event monitors and reports will state\nthat the person responsible for the override was the attributed cardholder, not the REST\noperator.  The REST operator will appear in a special mention in the event's details.\n\nFirst available in 8.70.  Versions older than 8.70 will ignore the parameter, leaving the\noverride attributed to the REST operator.\n"}},"responses":{"403outputoverride":{"description":"The site does not have the RESTOverrides licence (in which case the body of the result will\nsay so), or the operator does not have a privilege that allows overriding outputs (such as\n'Override', or 'Maintenance Override' for shunts).\n"}}},"paths":{"/api/outputs/{id}/cancel":{"post":{"tags":["Outputs"],"summary":"Cancel an override","description":"Cancels an override, returning the output to its previous state.\n","parameters":[{"$ref":"#/components/parameters/id"},{"$ref":"#/components/parameters/requested_by"}],"responses":{"204":{"description":"Success."},"403":{"$ref":"#/components/responses/403outputoverride"}}}}}}
```

## Monitor an output

> See the \[item status topic]\(item-status) for how to use the updates APIs.\
> \
> Note that this API call is good for watching one item only; if you want to monitor several,\
> you are better off with a \[status subscription]\(items#status-subscriptions).\
> \
> Follow the 'updates' field in an output \[summary]\(models#outputsummary) or\
> \[details]\(models#outputdetail) page to get here.<br>

```json
{"openapi":"3.2.0","info":{"title":"Command Centre REST API","version":"2.0"},"tags":[{"name":"Outputs","description":"These methods give you read access to Outputs in the Command Centre\ndatabase, and let you override them.\n\nThe first use case below introduces the main entry point.  It is a paginated search interface\nthat gives you any number of outputs, each containing the fields you ask for in the query,\nincluding (for example) the URLs you need to switch the outputs on and off.\n\n## Override times\n\n1. End times on overrides are not accurate to the second.  Internally, Command Centre\n   converts the end time to a duration, so you may find that submitting end times in\n   the very near future does not have the exact effect you expect.\n2. The end time you set for an override cannot be in the past or more than 24 hours\n   into the future.\n\n## Overrides always use 'on' and 'off'\n\nThe Configuration client allows you to assign different display strings to the two normal output\nstates, on and off.  On could be 'green', for example, and off could be 'red'.  Regardless, the\noverrides you apply to an output are called 'on' and 'off'.\n\n## Output status flags\n\nStatus flags, on the other hand, use the language of the relays on the hardware modules.  They\nwill report 'closed' for an output that is on, and 'open' for one that is off.\n\nIf the output is online, its `statusFlags` field may contain one or more of these flags:\n\n- `relayStateUnknown` means the controller does not know what the output should be doing.\n- `closed` means the output relay is closed.\n- `open` means the output relay is open.\n- `pulsed` means the relay's change in state is momentary.\n- `switchingDisabled` means switching this output is disabled.\n\n- `overridden` can appear whether the output is online or offline.  It means the output has an\n  override in effect.\n\n### Output flag rules\n\n- If and only if the output is online, one of 'relayStateUnknown', 'closed', or 'open' will\n  appear.  That is your test for whether an output is in error.\n- Of the above, only 'overridden' can appear when the output is offline.\n\n## Use cases\n\n### Listing Outputs\n1. `GET /api`.\n2. Follow the link at `features.outputs.outputs.href` [↪](outputs#get-api-outputs),\n   appending a search term such as `name=substring` to select the outputs, and `fields` to tell\n   the server what to return about each.  The next section covers those query parameters.\n3. Process the results, following the `next` link until there isn't one.\n\n### Switching an Output\n1. Find the href for the output using the process above.\n2. GET it.\n3. Look in the `commands` structure of the [results](models#outputdetail) to find the API\n   URLs that turn the output on, off, or cancel a previous override.  Use the `until` variants\n   if you want to specify an end time.\n4. POST to that URL.  Those with `until` in their command block keys require a JSON\n   object in the body; the others expect it empty.\n\n### Finding an output's status\n1. Find the href for the output using the process above, and GET it.\n3. Take the `updates` [↪](outputs#get-api-outputs-id-updates) href from that page.\n4. GET it.\n4. Use the flag rules above to interpret the status flags you receive.\n5. Follow the `next` link to stay up to date.\n\n## Licensing\n\nAll the POSTs that override items require RESTOverrides.\n\nIf you have RESTOverrides but not RESTStatus in 8.60 or later, the GETs return enough\ninformation to let you find the item you want to override but they do not return its status.  In\n8.50 and older, the GET will fail without RESTStatus.\n\nThe RESTOverrides and RESTStatus licences do not overlap: to watch the status of an item as well\nas override it, you will need both."}],"servers":[{"url":"https://127.0.0.1:8904"}],"security":[{"API_key":[]},{"basic":[]}],"components":{"securitySchemes":{"API_key":{"type":"apiKey","name":"Authorization","in":"header","description":"\nClients authenticate by including a pre-shared API key in the `Authorization` header of each\nrequest after an authorisation method of `GGL-API-KEY`:\n\n`Authorization: GGL-API-KEY C774-B01F-D695-AA4B-215F-A158-AC22-ADEB`\n\nFor a fuller description see [API authentication](api-authentication).\n"},"basic":{"type":"http","scheme":"basic","description":"This is HTTP Basic authentication using a blank username and the API key as the password.\n\nExample:  `Authorization: Basic OkM3NzQtQjAxRi1ENjk1LUFBNEItMjE1Ri1BMTU4LUFDMjItQURFQg==`\n\nThat example is equivalent to the example in the description of the api_Key method:\nprepending a colon to the API key beginning with `C774` then encoding it into Base64\nproduces the 56 characters beginning with `OkM3`.\n\nThe colon is a separator between a username, which is blank in our case, and the password,\nwhich is our API key.\n\nFor a fuller description see [API authentication](api-authentication)\n"}},"parameters":{"id":{"name":"id","in":"path","required":true,"schema":{"type":"string"},"description":"An internal identifier."},"updates_fields":{"name":"fields","in":"query","required":false,"style":"form","explode":false,"description":"This instructs the server to return these fields in the update, instead of the default set.\nYou will not hear about updates to fields you do not list.\n","schema":{"type":"string","enum":["status","statusText","statusFlags"]}}},"responses":{"403nolicence":{"description":"A server running 8.50 or earlier is missing the RESTStatus licence.  A server running 8.60\nor later is missing both the RESTStatus and RESTOverrides licences.  One of those is enough\nfor this API call in 8.60 and later.\n"},"404output":{"description":"The request's URL does not represent an output, or the operator does not have a privilege\non the output's division that allows viewing outputs, such as 'View Site', 'Edit Site', or\n'Override'.\n"}}},"paths":{"/api/outputs/{id}/updates":{"get":{"tags":["Outputs"],"summary":"Monitor an output","description":"See the [item status topic](item-status) for how to use the updates APIs.\n\nNote that this API call is good for watching one item only; if you want to monitor several,\nyou are better off with a [status subscription](items#status-subscriptions).\n\nFollow the 'updates' field in an output [summary](models#outputsummary) or\n[details](models#outputdetail) page to get here.\n","parameters":[{"$ref":"#/components/parameters/id"},{"$ref":"#/components/parameters/updates_fields"}],"responses":{"200":{"description":"Success.  See the [introduction](outputs) for a description of the three status\nfields.\n","content":{"application/json":{"schema":{"type":"object"}}}},"403":{"$ref":"#/components/responses/403nolicence"},"404":{"$ref":"#/components/responses/404output"}}}}}}
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://help.security.gallagher.com/knowledge-hub/developer/rest-api/outputs.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
